#import "DataVisionController.h"
#import "ReportBridge.h"

NSString	*sTypeParams[] = { @"-c ",@"-d ",@"-f ", @"-h ",@"-l ",@"-w ",@"-x " }	;

@implementation DataVisionController

- (NSArray *)makeTaskArguments
{
	NSMutableArray	*args = [NSMutableArray array]	;
	
		[args addObject:@"/usr/bin/java"]	;
		[args addObject:@"-classpath"]	;
		
	NSString	*pathToJars = [[NSBundle mainBundle] pathForResource:@"DataVision" ofType:@"jar" inDirectory:@"Java"]	;
	NSString	*classPath = [pathToJars stringByDeletingLastPathComponent]	;
	
	[args addObject:[NSString stringWithFormat:@"%@:%@:%@:%@:%@:%@",pathToJars, 
			[classPath stringByAppendingPathComponent:@"iText.jar"],
			[classPath stringByAppendingPathComponent:@"MinML2.jar"],
			[classPath stringByAppendingPathComponent:@"gnu-regexp-1.1.4.jar"],
			[classPath stringByAppendingPathComponent:@"jcalendar.jar"],
			[classPath stringByAppendingPathComponent:@"jruby.jar"]]]	;
		[args addObject:@"jimm.datavision.DataVision"]	;
		[args addObject:sTypeParams[[ibReportType indexOfSelectedItem]]];
		
		if ([[ibDelimiter stringValue] length] > 0)	{
			[args addObject:@"-s"]	;
			[args addObject:[ibDelimiter stringValue]]	;
		}
			
		if ([_parameterFileName length])	{	
			[args addObject:@"-r"]	;
			[args addObject:_parameterFileName]	;
		}
		if ([_dataFileName length])	{
			[args addObject:@"-e"]	;
			[args addObject:_dataFileName]	;
		}
		else	{
			if ([[ibPassword stringValue] length])	{
				[args addObject:@"-p"]	;
				[args addObject:[ibPassword stringValue]]	;
			}
			else	{
				[args addObject:@"-n"]	;
			}
		}
		if ([[ibLanguage stringValue] length] == 2)	{
			[args addObject:@"-g"]	;
			[args addObject:[ibLanguage stringValue]]	;
		}
		if ([[ibCountry stringValue] length] == 2)	{
			[args addObject:@"-i"]	;
			[args addObject:[ibCountry stringValue]]	;
		}
		if ([inSelectDataFileBtn intValue])
			[args addObject:@"-q"]	;
		
		
		if ([_reportFileName length])	
			[args addObject:_reportFileName]	;

		return args	;
}

- (void)updateCommandLine
{
	NSString	*command = [_commandBase stringByAppendingString:sTypeParams[[ibReportType indexOfSelectedItem]]]	;
	
		if ([[ibDelimiter stringValue] length] > 0)
			command = [command stringByAppendingString:[NSString stringWithFormat:@"-s %@ ",[ibDelimiter stringValue]]]	;
			
		if ([_parameterFileName length])	
			command = [command stringByAppendingString:[NSString stringWithFormat:@"-r \"%@\" ",_parameterFileName]]	;
		if ([_dataFileName length])	{
			command = [command stringByAppendingString:[NSString stringWithFormat:@"-e \"%@\" ",_dataFileName]]	;
		}
		else	{
			if ([[ibPassword stringValue] length])	{
				command = [command stringByAppendingString:[NSString stringWithFormat:@"-p %@ ",[ibPassword stringValue]]]	;
			}
			else	{
				command = [command stringByAppendingString:@"-n "]	;
			}
		}
		if ([[ibLanguage stringValue] length] == 2)
			command = [command stringByAppendingString:[NSString stringWithFormat:@"-g %@ ",[ibLanguage stringValue]]]	;
		if ([[ibCountry stringValue] length] == 2)
			command = [command stringByAppendingString:[NSString stringWithFormat:@"-i %@ ",[ibCountry stringValue]]]	;
		if ([inSelectDataFileBtn intValue])
			command = [command stringByAppendingString:@"-q "]	;
		
		
		if ([_reportFileName length])	
			command = [command stringByAppendingString:[NSString stringWithFormat:@"\"%@\"",_reportFileName]]	;

		[ibCommandLine setStringValue:command]	;
}

- (void)awakeFromNib
{
	NSString	*pathToJars = [[NSBundle mainBundle] pathForResource:@"DataVision" ofType:@"jar" inDirectory:@"Java"]	;
	NSString	*classPath = [pathToJars stringByDeletingLastPathComponent]	;
	
	_commandBase = [[[@"/usr/bin/java -classpath \"" stringByAppendingString:[NSString stringWithFormat:@"%@:%@:%@:%@:%@:%@",pathToJars, 
			[classPath stringByAppendingPathComponent:@"iText.jar"],
			[classPath stringByAppendingPathComponent:@"MinML2.jar"],
			[classPath stringByAppendingPathComponent:@"gnu-regexp-1.1.4.jar"],
			[classPath stringByAppendingPathComponent:@"jcalendar.jar"],
			[classPath stringByAppendingPathComponent:@"jruby.jar"]]] stringByAppendingString:@"\" jimm.datavision.DataVision "] retain]	;
		
		_reportFileName = @""	;
		_parameterFileName = @""	;
		_dataFileName = @""	;
		
		[self updateCommandLine]	;


		_reportBean = [[NSClassFromString(@"ReportBridge") alloc] init];
		
		if (_reportBean == nil)	
			NSLog(@"Problem loading bean")	;
}

- (IBAction)doClearReportName:(id)sender
{
		[ibReportName setStringValue:@""]	;
		[_reportFileName release]	;
		_reportFileName = @""	;
}

- (IBAction)doClearDataFileName:(id)sender
{
		[inDataFileName setStringValue:@""]	;
		[_dataFileName release]	;
		_dataFileName = @""	;
}

- (IBAction)doClearParametersName:(id)sender
{
		[ibParametersName setStringValue:@""]	;
		[_parameterFileName release]	;
		_parameterFileName = @""	;
}

- (IBAction)doRun:(id)sender
{
/*
	TaskWrapper	*taskWrapper = [[TaskWrapper alloc] initWithDelegate:self arguments:[self makeTaskArguments]]	;
	
		[taskWrapper startProcess]	;
*/
		[_reportBean setReportNameParamDataFile:_reportFileName :nil :'\0' :_dataFileName];
		[_reportBean runForPDFEngine:@"/tmp/test.pdf"]	;
}

- (IBAction)doSelectDataFile:(id)sender
{
	NSOpenPanel	*openPanel = [NSOpenPanel openPanel]	;
	
		[openPanel setAllowsMultipleSelection:NO]	;
		[openPanel setCanChooseDirectories:NO]		;
		[openPanel setCanChooseFiles:YES]			;
		
		if (NSOKButton == [openPanel runModalForTypes:[NSArray arrayWithObjects:@"csv",@"txt",@"text",nil]])	{
			[_dataFileName release]	;
			_dataFileName = [[[openPanel filenames] objectAtIndex:0] retain]	;
			[inDataFileName setStringValue:_dataFileName]	;
			[self updateCommandLine]	;
		}
}

- (IBAction)doSelectParameters:(id)sender
{
	NSOpenPanel	*openPanel = [NSOpenPanel openPanel]	;
	
		[openPanel setAllowsMultipleSelection:NO]	;
		[openPanel setCanChooseDirectories:NO]		;
		[openPanel setCanChooseFiles:YES]			;
		
		if (NSOKButton == [openPanel runModalForTypes:[NSArray arrayWithObjects:@"xml",nil]])	{
			[_parameterFileName release]	;
			_parameterFileName = [[[openPanel filenames] objectAtIndex:0] retain]	;
			[ibParametersName setStringValue:_reportFileName]	;
			[self updateCommandLine]	;
		}
}

- (IBAction)doSelectReport:(id)sender
{
	NSOpenPanel	*openPanel = [NSOpenPanel openPanel]	;
	
		[openPanel setAllowsMultipleSelection:NO]	;
		[openPanel setCanChooseDirectories:NO]		;
		[openPanel setCanChooseFiles:YES]			;
		
		if (NSOKButton == [openPanel runModalForTypes:[NSArray arrayWithObjects:@"xml",nil]])	{
			[_reportFileName release]	;
			_reportFileName = [[[openPanel filenames] objectAtIndex:0] retain]	;
			[ibReportName setStringValue:_reportFileName]	;
			[self updateCommandLine]	;
		}
}

- (IBAction)doSelectReportType:(id)sender
{
		[self updateCommandLine]	;
}

- (IBAction)doSetCountry:(id)sender
{
		[self updateCommandLine]	;
}

- (IBAction)doSetDelimiter:(id)sender
{
		[self updateCommandLine]	;
}

- (IBAction)doSetLanguage:(id)sender
{
		[self updateCommandLine]	;
}

- (IBAction)doSetPassword:(id)sender
{
		[self updateCommandLine]	;
}

- (IBAction)doTurnOffQuoting:(id)sender
{
		[self updateCommandLine]	;
}

- (void)appendOutput:(NSData *)output
{
}

- (void)appendError:(NSString *)output
{
}

- (void)processStarted
{
}

- (void)processFinished
{
}

- (void)setTask:(id)inTask
{
}

- (void)taskCompleted:(NSNotification *)inNotification
{
}

@end
