//
//  ReportBridge.java
//  AvocatDesk
//
//  Created by Pascal Pochet on Tue Jul 15 2003.
//  Copyright (c) 2003 P3 Consulting. All rights reserved.
//

import java.lang.*;
import java.io.*;
import java.sql.*;

import jimm.datavision.*;
import jimm.datavision.layout.pdf.*;
import jimm.datavision.source.charsep.*;

public class ReportBridge {
	Report	_report	;
	
	ReportBridge()	{
		try	{
			_report = new Report()	;
		}
		catch(Exception e)	{
		}
	}
	
	public void setReportNameParamPasswordJDBC(String inReportName,String inParamFile,String inPassword,Connection inDB)	{
		try	{
			_report.setDatabasePassword(inPassword)	;
			_report.read(inReportName)	;
			if (inParamFile != null)
				_report.setParameterXMLInput(inParamFile)	;
			_report.setDatabaseConnection(inDB)	;
		}
		catch(Exception e)	{
		}
	}
	
	public void setReportNameParamDataFile(String inReportName,String inParamFile,char inSep,String inDataFilePath)	{
		try	{
			_report.read(inReportName)	;
			if (inParamFile != null)
				_report.setParameterXMLInput(inParamFile)	;
			
			CharSepSource src = (CharSepSource)_report.getDataSource()	;
			if (inSep != '\0')
				src.setSepChar(inSep)	;
			src.setInput(inDataFilePath)	;
		}
		catch(Exception e)	{
		}
	}
	
	public void runForPDFEngine(String inOutputFileName)	{
		try	{
			PrintWriter out = new PrintWriter(new FileWriter(inOutputFileName))	;
		
			_report.setLayoutEngine(new PDFLE(out))	;
			ErrorHandler.useGUI(false);
			_report.run();
		}
		catch(Exception e)	{
		}
	}
	
}
